/* образ сочетания действия с Пульта (кроме словестных)

*/

package psychic

import (
	"BOT/lib"
	"strconv"
	"strings"
)
//////////////////////////////////////////////



/////////////////////////////////////////////

func loadActivityInit(){

	loadActivityFromIdArr()

}
////////////////////////////////////////////

/* для оптимизации поиска по дереву перед узлом Activity идет узел первого символа : var symbolsArr из word_tree.go

 */
type Activity struct {
	ID int
	ActID[] int // массив ID действий с Пульта 
	Weight int // вес значимости для конкуренции
	Positive int // позитивность - оценка стимулирующей силы
	Negjtive int  // негативность - оценка силы избегания
}
var ActivityFromIdArr=make(map[int]*Activity)
//////////////////////////////////////////
func createInactionImg(){
	_,PsyActionImg=createNewlastActivityID(1,[]int{0})
}

// создать образ сочетаний пусковых стимулов
//В случае отсуствия пусковых стимулов создается ID такого отсутсвия, пример такой записи: 2|||0|0| - ID=2
var lastActivityID=0
func createNewlastActivityID(id int,ActID []int)(int,*Activity){
	oldID,oldVal:=checkUnicumActivity(ActID)
	if oldVal!=nil{
		return oldID,oldVal
	}
	if id==0{
		lastActivityID++
		id=lastActivityID
	}else{
		//		newW.ID=id
		if lastActivityID<id{
			lastActivityID=id
		}
	}

	var node Activity
	node.ID = id
	node.ActID = ActID

	ActivityFromIdArr[id]=&node
	return id,&node
}
func checkUnicumActivity(ActID []int)(int,*Activity){
	for id, v := range ActivityFromIdArr {
		if !lib.EqualArrs(ActID,v.ActID) {
			continue
		}
		return id,v
	}

	return 0,nil
}
/////////////////////////////////////////
// создать новый образ сочетаний действий, если такого еще нет
func CreateNewActivityImage(ActID []int)(int,*Activity){
	if ActID==nil{
		return 0,nil
	}

	id,verb:=createNewlastActivityID(0,ActID)

	SaveActivityFromIdArr()

	return id,verb
}

/////////////////////////////////////////

//////////////////// сохранить образы сочетаний пусковых стимулов
//В случае отсуствия пусковых стимулов создается ID такого отсутсвия, пример такой записи: 2|||0|0|
func SaveActivityFromIdArr(){
	var out=""
	for k, v := range ActivityFromIdArr {
		out+=strconv.Itoa(k)+"|"
		for i := 0; i < len(v.ActID); i++ {
			out+=strconv.Itoa(v.ActID[i])+","
		}
		out+="|"
		out+=strconv.Itoa(v.Weight)+"|"
		out+=strconv.Itoa(v.Positive)+"|"
		out+=strconv.Itoa(v.Negjtive)+"|"
		out+="\r\n"
	}
	lib.WriteFileContent(lib.GetMainPathExeFile()+"/memory_psy/activity_images.txt",out)

}
////////////////////  загрузить образы сочетаний пусковых стимулов
func loadActivityFromIdArr(){
	ActivityFromIdArr=make(map[int]*Activity)
	// сразу создать первым образ бездействий с Пульта - самое частое состояние
	createInactionImg()
	strArr,_:=lib.ReadLines(lib.GetMainPathExeFile()+"/memory_psy/activity_images.txt")
	cunt:=len(strArr)
	for n := 0; n < cunt; n++ {
		if len(strArr[n])==0{
			continue
		}
		p:=strings.Split(strArr[n], "|")
		id,_:=strconv.Atoi(p[0])
		s:=strings.Split(p[1], ",")
		var ActID[] int
		for i := 0; i < len(s); i++ {
			if len(s[i])==0{
				continue
			}
			si,_:=strconv.Atoi(s[i])
			ActID=append(ActID,si)
		}
		Weight,_:=strconv.Atoi(p[2])
		Positive,_:=strconv.Atoi(p[3])
		Negjtive,_:=strconv.Atoi(p[4])

		_,v:=createNewlastActivityID(id,ActID)
		v.Weight=Weight
		v.Positive=Positive
		v.Negjtive=Negjtive
	}
	return

}
///////////////////////////////////////////